<template>
  <div class="container mx-auto">
    <div class="w-full mt-5 blue-customize">
      <lobby-entry-filter
        :key="gameEntryFilterKey"
        v-model:search="searchedGame"
        :menus="gameEntryTabMenus"
        @onFilterClicked="onFilter"
        @search-games="updateSearchResult"
      />
      <lobby-render
        :loading="isLoading"
        :games="gameCollection"
        :isHasGroupTitle="true"
        :groupTitle="gameGroupTitle"
        classGameName="text-white"
        :show-staus="true"
      />
    </div>
  </div>
</template>
<script lang="ts">
import { computed, defineComponent, ref, watch } from "vue";
import { IGameEntryMenu, TabGameMenu } from "@/models/gameEntryFilter";
import { useGameEntryComponent } from "@/composables/useTheme";
import { GameFilterRequest } from "@/models/bsiGameList";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

export default defineComponent({
  name: "game",
  setup() {
    const {
      isLoading,
      headerTab,
      initialGameEntry,
      authenticated,
      getGameEntryFiltered,
      searchedGame,
      handleSearchGame,
      updateSearchResult,
      gameCollection,
    } = useGameEntryComponent();
    const gameEntryFilterKey = computed(() => (headerTab.value ? 1 : 0));
    const gameEntryTabMenus = computed(() => {
      const result: IGameEntryMenu[] = [
        {
          Menus: headerTab.value?.map(
            (item) => new TabGameMenu(item, "blue_sbo_3")
          ),
          IsSearchBox: false,
          Justify: "left",
          Theme: "common",
        },
        {
          Menus: [],
          IsSearchBox: true,
          Justify: "left",
          Theme: "blue_sbo_3",
        },
      ];
      return result;
    });
    const gameGroupTitle = ref("Top Games");
    const onFilter = (request: GameFilterRequest) => {
      getGameEntryFiltered(request);
      gameGroupTitle.value =
        request.Value === "" ? request.Type : request.Value;
    };
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const banner1 = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "games_banner_1"
        )
    );
    const gameBanners = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          "games_banner_"
        )
    );
    const banners = gameBanners.value.filter(
      (item) => item.HtmlId !== "games_banner_1"
    );
    watch(searchedGame, () => {
      handleSearchGame();
    });
    return {
      gameEntryTabMenus,
      searchedGame,
      onFilter,
      initialGameEntry,
      gameGroupTitle,
      authenticated,
      banner1,
      banners,
      isLoading,
      handleSearchGame,
      gameEntryFilterKey,
      updateSearchResult,
      gameCollection,
    };
  },
});
</script>
<style>
.text-color-blue {
  color: #596d86 !important;
}
</style>
<style lang="scss">
:root {
  --gf-background-color: var(--primary);
  --new-text-color: white;
  --dropdown-text-color: white;
}
.blue-customize {
  .game-filter-bg {
    background-color: transparent;
  }
  position: relative;
  .grid.grid-cols-10 {
    grid-template-columns: repeat(12, minmax(0, 1fr));
  }
  .game-filter {
    margin-bottom: 15px;
  }
  .grid {
    margin-bottom: 15px;
    .col-span-2 {
      border: none;
      .cursor-pointer div {
        justify-content: center;
        // height: 38px;
      }
      .cursor-pointer img {
        width: 100%;
      }
    }
  }

  .game-tab-icon-active {
    filter: invert(3%) sepia(60%) saturate(1988%) hue-rotate(158deg)
      brightness(91%) contrast(101%);
  }
  .grid .flex .flex {
    .game-tab-menu .flex {
      flex-direction: row;
      margin-bottom: 8px;
      .game-tab-icon,
      .game-tab-icon-active {
        width: 1.25rem;
        height: auto;
      }
      .game-tab-icon-active {
        filter: invert(3%) sepia(60%) saturate(1988%) hue-rotate(158deg)
          brightness(91%) contrast(101%);
      }
    }
    span {
      color: white;
    }
  }
  .grid .w-full .w-full div .search-box {
    position: absolute;
    left: 40%;
    top: 3px;
    background-color: transparent;
    border: 1px solid white;
    border-radius: 5px;
    width: auto;
    .el-input__inner {
      color: white;
    }
    span {
      color: white;
    }
  }
  div .w-full.text-white {
    display: none;
  }
}
</style>
